<template>
  <div id="deviceList">
    <el-row class="right">
      <span style="float:left;">当前选择的设备族:{{category.name}}</span>
      <el-select v-model="showType" @change="initTable" style="width:125px;margin-right:10px;vertical-align:bottom;">
        <el-option v-for="item in showTypes" :key="item.value" :label="item.label" :value="item.value"></el-option>
      </el-select>
      <span>增加</span>
      <el-input v-model="addNum" style="width:50px;" size="small"></el-input>
      <span>个{{category.name}}</span>
      <el-button @click="handleAddTableRow">增加</el-button>
    </el-row>
    <div class="tableBox">
      <div class="center middle_sty" style="flex:2;" v-show="tableData && !tableData.length">
        <p>
          <i class="icon-wushuju iconfont"></i>
          暂无数据
        </p>
      </div>
      <div class="tableLeft" v-show="tableData && tableData.length">
        <handson-table ref="table"></handson-table>
      </div>
    </div>
    <el-row class="center">
      <el-button type="primary" size="medium" @click="handleCreateTableData" class="create_button">创建资产</el-button>
    </el-row>
    <!-- 型号弹窗 -->
    <firm :mess="{deviceId: category.Family}" ref="firm" @changeFirm="firmChange" :dialog="myDialog"></firm>
    <!-- 供应商合同弹窗 -->
    <supply-dialog ref="supply" @change="supplyChange" :id="id" :dialog="myDialog"></supply-dialog>
    <!-- 供应商弹窗 -->
    <supplier-dialog ref="supplier" @changeSupplier="supplierChange" :dialog="myDialog"></supplier-dialog>
    <guarantee-dialog :id="id" ref="guarantee" @change="guaranteeChange" :dialog="myDialog"></guarantee-dialog>
    <upload-files-dialog :read="onlyRead ? true : false" ref="upload" @changeFile="fileChange" :keysArr="filesArr" :dialog="myDialog"></upload-files-dialog>
    <upload-img-dialog :read="onlyRead ? true : false" @changeFile="imgChange" :keysArr="imgsArr" :dialog="myDialog"></upload-img-dialog>
    <maintainer-dialog @changeMaintainer="changeMaintainer" ref="maintainer" :dialog="myDialog"></maintainer-dialog>
    <insurer-dialog @changeInsurer="changeInsurer" ref="insurer" :dialog="myDialog"></insurer-dialog>
    <pic-dialog :read="onlyRead ? true : false" :dialog="myDialog" :keysArr="picsArr" @change="changePics"></pic-dialog>
    <details-dialog :iframeSrc="iframeSrc" v-if="myDialog.details" :dialog="myDialog"></details-dialog>
  </div>
</template>
<script>
import tools from "@/utils/scan/tools"
import handsonUtils from "@/utils/hasontableUtils"
import showTools from "@/utils/handsontable/notShow"
import text from "@/utils/handsontable/mainText"
import session from "@/framework/utils/storage"
import buildFloor from '@/utils/handsontable/buildFloorData'

import handsonTable from "@/components/common/handsontable"
import { getDataDictionary, createPropertyData } from "@/api/scan/request"
import { mapGetters, mapActions } from "vuex"

import firm from "@/components/dialogs/list/firm"
import supplyDialog from "@/components/dialogs/list/supplyDialog"
import supplierDialog from "@/components/dialogs/list/supplierDialog"
import maintainerDialog from "@/components/dialogs/list/maintainerDialog"
import insurerDialog from "@/components/dialogs/list/insurerDialog"
import guaranteeDialog from "@/components/dialogs/list/guaranteeDialog"
import uploadFilesDialog from "@/components/dialogs/list/filesDialog"
import uploadImgDialog from "@/components/dialogs/list/uploadImgDialog"
import picDialog from "@/components/dialogs/list/picDialog"
export default {
  components: {
    firm, //品牌型号弹窗
    supplyDialog,
    supplierDialog,
    maintainerDialog,
    insurerDialog,
    guaranteeDialog,
    uploadFilesDialog,
    uploadImgDialog,
    picDialog,
    handsonTable
  },
  data() {
    return {
      addNum: 1,
      onlyRead: false,
      showTypes: [{ value: "partInfo", label: '隐藏信息点' }, { value: "all", label: '全部' }, { value: "Visible", label: '只看采集信息' }],
      buildFloorData: [],
      tableHeader: [],
      tableData: session.get("propertyAddData")
        ? session.get("propertyAddData").length
          ? session.get("propertyAddData")
          : [{}]
        : [{}],
      copyTableData: [],
      category: "", //当前设备类
      myDialog: {
        firm: false, //厂商弹窗
        supply: false, //选择供应合同
        supplier: false, //供应商选择
        guarantee: false, //选择保单
        maintainer: false, //选择维修商
        insurer: false, //选择保险公司
        uploadFiles: false, //上传文件
        uploadImgs: false, //上传单个图片
        pic: false, //多个图片
        addDevice: false,
        systemType: false,
        details: false, //详情页
        lookPic: false //图片查看
      },
      qrcodeUrl: "", //二维码图片地址
      filesArr: [], //保存临时的文件key
      imgsArr: [], //临时保存的图片key数组
      picsArr: [], //临时设备图片keys数组
      systemId: null,
      graphyId: null,
      id: 0,
      showType: this.$route.query.showType,
      EquipmentList: []
    };
  },
  computed: {
    ...mapGetters("layout", ["projectId", "secret", "userId"])
  },
  created() {
    this.category = this.$route.query;
    buildFloor.getData(this.buildFloorData)
    this.getTableHeader();
  },
  methods: {
    // 获取表头数据(初始化表格)
    async getTableHeader() {
      let params = {
        data: {
          Orders: "sort asc, InfoPointName desc",
          PageNumber: 1,
          PageSize: 1000
        },
        type: this.category.Family
      };
      await getDataDictionary(params, res => {
        this.tableHeader = res.Content;
        this.initTable();
      });
    },
    // 创建资产数据
    async handleCreateTableData() {
      let params = {}
      let newData = this.tableData.filter(item => {
        let keys = Object.keys(item)
        keys.map(key => {
          //将值为空字符串的属性删除
          if (item[key] == "") {
            delete item[key];
          }
        });
        let newK = Object.keys(item)
        if (keys.length && newK.length) {
          return item;
        }
      })
      if (!newData.length) {
        this.$message("创建信息为空,请录入信息后再创建!");
        return;
      }
      let flag = false;
      newData.map(item => {
				item.Family = this.category.Family
        if (!item.EquipLocalName) {
          flag = true
        }
        // 处理建筑-楼层
        if (item.flowBuild) {
					let BuildingId = item.flowBuild.split("-")[0]
					let FloorId = item.flowBuild.split("-")[1]
					if (BuildingId && FloorId) {
						item.BuildingId = BuildingId
          	item.FloorId = FloorId
					} else if (BuildingId && !FloorId) {
						item.BuildingId = BuildingId
					}
				}
      })
      if (flag) {
        this.$message.info("存在设备的本地名称为空，请检查")
        return;
			}
			params.Content = newData
			await createPropertyData(params, res => {
        this.$message.success("添加成功!")
        session.remove("propertyAddData")
				this.$router.push({
					name: "propertyLedger",
					params: { Family: this.category.Family }
				})
			})
    },
    // 删除表格行
    handleDeleteTableRow() {
      this.$message.success("删除成功")
      this.formaTableData()
    },
    // 添加行
    handleAddTableRow() {
      let addRowLength = this.addNum
      for(let i = 0; i < addRowLength; i++){
        this.tableData.push({})
      }
      this.initTable()
      this.formaTableData()
    },
    //修改
    handleUpdataTable(changeData, source) {
      if (!this.onlyRead && source != 'ObserveChanges.change') {
        this.formaTableData()
      }
    },
    //保存去掉空字段的新增数据
    formaTableData() {
      let newData = this.tableData.filter(item => {
        let keys = Object.keys(item)
        keys.map(key => {
          //将值为空字符串的属性删除
          if (item[key] == "") {
            delete item[key]
          }
        })
        if (keys.length && Object.keys(item).length) {
          return item;
        }
      })
      session.set("propertyAddData", newData);
    },
    //格式化表头显示的数据
    formatHeaderData(list) {
      let arr = tools.copyArr(list)
      let data = showTools.headerTextFilter(arr, 'property', this.onlyRead, this.showType, true)
      data.unshift("所属建筑楼层")
      return data
    },
    //格式化表头头映射的数据
    formatHeaderType(list) {
      let arr = tools.copyArr(list)
      let data = showTools.headerTypeFilter(arr, 'property', this.onlyRead, this.showType, true)
      data.unshift({
        data: "flowBuild",
        renderer: tools.customDropdownRenderer,
        editor: "chosen",
        chosenOptions: {
            data: this.buildFloorData
        }
      })
      return data
    },
    initTable() {
      //实例化表格
      let settings = {
        data: this.tableData,
        colHeaders: this.formatHeaderData(this.tableHeader),
        columns: this.formatHeaderType(this.tableHeader),
        rowHeights: 30,
        maxRows: this.tableData.length,
        contextMenu: this.onlyRead ? false :{
          items: {
            remove_row: {
              name: "删除资产"
            }
          }
        },
        // 事件
        afterChange: this.handleUpdataTable, //修改后
        afterFilter: this.trimmedRows, //排序前
        afterRemoveRow: this.handleDeleteTableRow, //右键删除
        afterOnCellMouseDown: this.handleTdClick //鼠标点击
      };
      this.$nextTick(() => {
        this.tableExample = this.$refs.table.init(settings);
      });
    },
    //去除数组中相同的元素
    array_diff(a, b) {
      for (var i = 0; i < b.length; i++) {
        for (var j = 0; j < a.length; j++) {
          if (a[j] == b[i]) {
            a.splice(j, 1);
            j = j - 1;
          }
        }
      }
      return a;
    },
    //选择型号修改
    firmChange(data) {
      tools.setDataForKey(this.tableData[this.row], "DPManufacturerID", data.venderId)//生产商ID
      tools.setDataForKey(this.tableData[this.row], "DPBrandID", data.brandId)//品牌ID
      tools.setDataForKey(this.tableData[this.row], "DPSpecificationID", data.specificationId)//型号ID
      tools.setDataForKey(this.tableData[this.row], "LedgerParam.EquipManufactor.Manufacturer", data.venderName)
      tools.setDataForKey(this.tableData[this.row], "LedgerParam.EquipManufactor.Brand", data.brandName)
      tools.setDataForKey(this.tableData[this.row], "LedgerParam.EquipManufactor.Specification", data.name)
    },
    supplyChange(data) {
      tools.setDataForKey(this.tableData[this.row], "LedgerParam.SupplyPurchase.SupplierContractID", { id: data })
    },
    //如果选择供应商之后
    supplierChange(data) {
      tools.setDataForKey(this.tableData[this.row], "DPSupplierID", data.venderId)
      tools.setDataForKey(this.tableData[this.row], "LedgerParam.SupplyPurchase.Supplier", data.name)
    },
    //保险合同
    guaranteeChange(data) {
      for (let key in data) {
        this.utilToKey(key, "insuranceNo", data, "InsuranceNum");
        if (key == "contractFile") {
          if (!!data[key]) {
            data[key] = [data[key]];
          }
        }
        this.utilToKey(key, "contractFile", data, "InsuranceFile");
      }
    },
    //上传文件弹窗触发事件
    fileChange(keys) {
      this.setDataToMain(keys, this.messKey, this.row);
    },
    //上传图片弹窗触发事件
    imgChange(keys) {
      this.setDataToMain(keys, this.messKey, this.row);
    },
    //维修商变更
    changeMaintainer(data) {
      tools.setDataForKey(this.tableData[this.row], "LedgerParam.OperationMainte.Maintainer", data.name)
      tools.setDataForKey(this.tableData[this.row], "DPMaintainerID", data.venderId)
    },
    //保险商变更
    changeInsurer(data) {
      tools.setDataForKey(this.tableData[this.row], "LedgerParam.InsuranceDoc.Insurer", data.name)
      tools.setDataForKey(this.tableData[this.row], "DPInsurerID", data.venderId)
    },
    //设备图片弹窗改变事件
    changePics(keys) {
      this.setDataToMain(keys, this.messKey, this.row);
    },
    //表格点击事件
    handleTdClick(el, rowArr) {
      //点击的是表头
      if (rowArr.row < 0) {
        return;
      }
      //被筛选过后的数组
      let trimmedArr = this.trimmedRows();
      //是否启用了排序
      let isSort = this.tableExample.getPlugin("columnSorting").isSorted();
      if (trimmedArr.length && isSort) {
        let sortArr = this.myHotArr.getPlugin("columnSorting").rowsMapper
          .__arrayMap;
        let infos = this.tableData[trimmedArr[sortArr[rowArr.row]]];
        this.getInfors(infos, { row: sortArr[rowArr.row], col: rowArr.col });
      } else if (isSort) {
        //排序后的数组
        let sortArr = this.tableExample.getPlugin("columnSorting").rowsMapper
          .__arrayMap;
        let infos = this.tableData[sortArr[rowArr.row]];
        this.getInfors(infos, { row: sortArr[rowArr.row], col: rowArr.col });
      } else if (trimmedArr.length) {
        let infos = this.tableData[trimmedArr[rowArr.row]];
        this.getInfors(infos, { row: trimmedArr[rowArr.row], col: rowArr.col });
      } else {
        let infos = this.tableData[rowArr.row];
        this.getInfors(infos, rowArr);
      }
    },
    //获取被筛选掉的行号
    trimmedRows() {
      var plugin = this.tableExample.getPlugin("trimRows").trimmedRows;
      let dataLength = this.tableData.length;
      let dataArr = new Array();
      for (let i = 0; i < dataLength; i++) {
        dataArr.push(i);
      }
      if (plugin.length <= 0) {
        dataArr = undefined;
      } else {
        dataArr = this.array_diff(dataArr, plugin);
      }
      return dataArr || [];
    },
    getInfors(infos, row) {
      let val = this.tableExample.colToProp(row.col);
      switch (val) {
        //品牌型号弹窗
        case 'DPManufacturerID':
          if (!this.onlyRead) {
            this.myDialog.firm = true;
          }
          break;
        //供应商信息弹窗
        case 'DPSupplierID':
          if (!this.onlyRead) {
            this.myDialog.supplier = true;
          }
          break;
        //维修商信息弹窗
        case 'DPMaintainerID':
          if (!this.onlyRead) {
            this.myDialog.maintainer = true;
          }
          break;
        //保险公司信息
        case 'DPInsurerID':
          if (!this.onlyRead) {
            this.myDialog.insurer = true;
          }
          break;
        //供应合同编号
        case 'LedgerParam.SupplyPurchase.SupplierContractID':
          if (!this.onlyRead) {
            let ContractIDflag = null;
            let DPSdata = this.tableData[row.row].DPSupplierID;
            if (DPSdata) {
              ContractIDflag = DPSdata.split("-")[0];
            }
            if (!!ContractIDflag) {
              this.id = ContractIDflag;
              this.myDialog.supply = true;
            } else {
              this.$message("请先选择供应商");
            }
          }
          break;
        //保险单号
        case 'LedgerParam.InsuranceDoc.InsuranceNum':
          if (!this.onlyRead) {
            let DPInsurerIDflag = null;
            let DPIdata = this.tableData[row.row].DPInsurerID;
            if (DPIdata) {
              DPInsurerIDflag = DPIdata.split("-")[0];
            }
            if (!!DPInsurerIDflag) {
              this.id = DPInsurerIDflag;
              this.myDialog.guarantee = true;
            } else {
              this.$message("请先选择保险商");
            }
          }
          break;
        //保险文件--设备文档--安装质检报告
        case 'LedgerParam.InsuranceDoc.InsuranceFile': //保险文件
        case 'LedgerParam.PhotoDoc.Archive': //设备文档
        case 'LedgerParam.Siteinstall.CheckReport': //安装质检报告
        case 'LedgerParam.OperationMainte.MaintainManual': //维修保养手册
        case 'LedgerParam.SupplyPurchase.ApproachingAcceptance': //进场验收单
        case 'LedgerParam.SupplyPurchase.AcceptanceReport': //验收报告
        case 'LedgerParam.PhotoDoc.OperationManual': //操作说明书
        case 'LedgerParam.EquipManufactor.OriginalCertificate': //原厂证明
        case 'LedgerParam.EquipManufactor.TestReport': //检测报告
        case 'LedgerParam.PhotoDoc.ProductCertification': //产品合格证
        case 'LedgerParam.Siteinstall.InstallInstruction': //安装说明书
        case 'LedgerParam.SupplyPurchase.SupplierContract': //供应合同
        case 'LedgerParam.PhotoDoc.Drawing': //设备图纸
        case 'LedgerParam.Siteinstall.InstallDrawing': //安装图纸
          let IPSdata = tools.dataForKey(this.tableData[row.row], val);
          this.filesArr = IPSdata ? IPSdata : [];
          this.myDialog.uploadFiles = true;
          break;
        //安装照片--设备铭牌照片
        case 'LedgerParam.Siteinstall.InstallPic':
        case 'LedgerParam.PhotoDoc.Nameplate':
          let SSPPdata = tools.dataForKey(this.tableData[row.row], val);
          this.imgsArr = SSPPdata ? SSPPdata : [];
          this.myDialog.uploadImgs = true;
          break;
        //设备照片
        case 'LedgerParam.PhotoDoc.Pic':
          let Pdata = tools.dataForKey(this.tableData[row.row], val);
          this.picsArr = Pdata ? Pdata : [];
          this.myDialog.pic = true;
          break;
        default:
          break;
      }
      this.row = row.row;
      this.messKey = val;
    },
    utilToKey(key, name, data, messName) {
      if (key == name) {
        this.setDataToMain(data[key], messName, this.row);
      }
    },
    //判断是否有值，有值赋值
    setDataToMain(data, key, row) {
      if (!!data && data != "--") {
        if (!!this.tableData[row]) {
          //铭牌照片特殊处理
          tools.setDataForKey(this.tableData[row], key, data)
          // this.tableData[row][key] = data;
        } else {
          this.tableData[row] = {};
          tools.setDataForKey(this.tableData[row], key, data)
        }
      } else {
        tools.setDataForKey(this.tableData[row], key, "")
      }
    }
  }
};
</script>
<style lang="less" scoped>
#deviceList {
  overflow: hidden;
  height: 100%;
  background-color: #fff;
  padding: 10px;
  position: relative;
  .right {
    background: #fff;
  }
  .search-header {
    overflow: hidden;
    padding: 0 10px 10px 10px;
    border-bottom: 1px solid #bcbcbc;
  }
  .tableBox {
    display: flex;
    height: calc(100% - 100px);
    margin-top: 10px;
    .tableLeft {
      flex: 1;
    }
  }
  .create_button {
    margin-top: 10px;
  }
}
</style>
